<?php
//ini_set("display_errors",1);
//error_reporting(E_ALL);
/**
 * @version		1.0
 * @package		Joomla
 * @subpackage	Payment Form
 * @subpackage	OkPay 
 * @author  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu 
 * @copyright	Copyright  2013 - All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 */

class os_okpay extends os_payment {
	/**
	 * Payment url
	 *
	 * @var string
	 */
	var $_url = null ;
	/**
	 * Array of params will be posted to server
	 *
	 * @var string
	 */
	var $_params = array();
	/**
	 * Array containing data posted from 2checkout to our server
	 *
	 * @var array
	 */
	var $_data = array();
	/**
	 * Constructor functions, init some parameter
	 *
	 * @param object $params
	 */
	function os_okpay($params) {
		parent::setName('os_okpay');
		parent::os_payment();						
		parent::setCreditCard(false);		
    	parent::setCardType(false);
    	parent::setCardCvv(false);
    	parent::setCardHolderName(false);
		$this->ipn_log = true ;
		$this->ipn_log_file = JPATH_COMPONENT.DS.'okpay_logs.txt';		
		$this->_url = 'https://www.okpay.com/process.html';	
		$this->setParam('ok_receiver', $params->get('okpay_user'));
    $this->setParam('ok_currency', $params->get('okpay_currency'));			
	}
	/**
	 * Set param value
	 *
	 * @param string $name
	 * @param string $val
	 */
	function setParam($name, $val) {
		$this->_params[$name] = $val;
	}
	/**
	 * Setup payment parameter
	 *
	 * @param array $params
	 */
	function setParams($params) {
		foreach ($params as $key => $value) {
			$this->_params[$key] = $value ;
		}
	}
	/**
	 * Payment processing
	 *
	 * @param object $row
	 * @param array $data
	 */
	function processPayment($row, $data) {
    $siteUrl = JURI::base() ;					
		$Itemid = JRequest::getInt('Itemid') ;
		//Billing address
		$this->setParam('ok_payer_first_name', $row->first_name);
		$this->setParam('ok_payer_last_name', $row->last_name);
		$this->setParam('ok_payer_street', $row->address);
		$this->setParam('ok_payer_city', $row->city);
		$this->setParam('ok_payer_state', $row->state);
		$this->setParam('ok_payer_zip', $row->zip);
		$this->setParam('ok_payer_country_code', $row->country);
		$this->setParam('ok_payer_email', $row->email);
		$this->setParam('ok_invoice', $row->id);
		$this->setParam('ok_item_1_name', $data['item_name']);
    $this->setParam('ok_item_1_quantity', '1');
		$this->setParam('ok_item_1_price', number_format(round($data['amount'], 2),2));
    $this->setParam('ok_return_success', $siteUrl.'index.php?option=com_pmform&view=complete&id='.$row->id.'&Itemid='.$Itemid);		
		$this->setParam('ok_return_fail', $siteUrl.'index.php?option=com_pmform&view=cancel&id='.$row->id.'&Itemid='.$Itemid);
    $this->setParam('ok_ipn', $siteUrl.'index.php?option=com_pmform&task=payment_confirm&payment_method=os_okpay');
		$this->submitPost();		
	}
	/**
	 * Submit post to OkPay server
	 *
	 */	
	function submitPost() {
    if(trim($this->_params['ok_receiver'])=='')
    {
      ?>
      <font color="red"><strong>Please input your OkPay Wallet ID</strong></font>
      <?php
    }
    else
    {
		?>			
		<div class="contentheading"><?php echo  JText::_('OS_WAIT_OKPAY'); ?></div>							
		<form method="post" action="<?php echo $this->_url; ?>" name="os_form" id="os_form">
			<?php
				foreach ($this->_params as $key=>$val) {
					echo '<input type="hidden" name="'.$key.'" value="'.$val.'" />';
					echo "\n";	
				}
			?>
			<script type="text/javascript">
				function redirect() {
					document.os_form.submit();
				}
				setTimeout('redirect()',3000);
			</script>
		</form>
	<?php
    }
	}
	/**
	 * Validate the post data from OkPay to our server
	 *
	 * @return string
	 */
	function _validate() {		  
	    foreach ($_REQUEST as $key=>$value) { 
	       $this->_data[$key] = $value;	     
	    }
	    $id = JRequest::getInt('ok_invoice', 0) ;    		    		    	      	   
	    $this->log_ipn_results(true); 	   
	    if (!$id)
	    	return false ;
	    $OKPayHelper= new OKPayHelper();

      $error_msg = $OKPayHelper->_processIPN ($_POST);
      
      if($error_msg!='')
      {
        return false;
      }
      else
      {
      if (strcmp ($_POST['ok_txn_status'], 'completed') == 0) {
        return true;
        } elseif (strcmp ($_POST['ok_txn_status'], 'pending') == 0) {
        exit;//pending just exit
        } elseif (isset ($_POST['ok_txn_status'])) {
        return false;
        } else {
        return false;
      }
      }
	}
	/**
	 * Log IPN result
	 *
	 * @param string $success
	 */
	function log_ipn_results($success) {
      if (!$this->ipn_log) return;
      $text = '['.date('m/d/Y g:i A').'] - '; 
      if ($success) $text .= "SUCCESS!\n";
      	else $text .= 'FAIL: '.$this->last_error."\n"; 
      $text .= "IPN POST Vars from okpay:\n";
      foreach ($this->_data as $key=>$value) {
         $text .= "$key=$value, ";
      }
      $text .= "\nIPN Response from okpay Server:\n ".$this->ipn_response;
      $fp=fopen($this->ipn_log_file,'a');
      fwrite($fp, $text . "\n\n"); 
      fclose($fp);  // close file
   }
	/**
	 * Process payment 
	 *
	 */
	function verifyPayment() {
	    $mainframe = & JFactory::getApplication() ;
	    $Itemid = JRequest::getInt('Itemid');		
		$ret = $this->_validate();
    $id = $this->_data['ok_invoice'];			
		if ($ret) {
			$config = PmFormHelper::getConfig() ;
			$row = & JTable::getInstance('pmform', 'Payment');
   			$row->load($id);				
   			$transactionId = @$this->_data['ok_txn_id'];
   			$row->transaction_id = $transactionId ;
   			$row->payment_date =  date('Y-m-d H:i:s');
   			$row->published = 1;
   			$row->store();						
			PmFormHelper::sendEmails($row, $config);	   			
			JPluginHelper::importPlugin( 'pmform' );
			$dispatcher =& JDispatcher::getInstance();
			$dispatcher->trigger( 'onAfterPaymentSuccess', array($row));
   			return true;	
		} else {
			$mainframe->redirect('index.php?option=com_pmform&view=failure&id='.$id.'&Itemid='.$Itemid);
			return false;
		}		     
	}		
}
class OKPayHelper {
	/*
	 * CheckOKPayIPs
	 * Cannot be checked with Sandbox
	 * From VM1.1
	*/
	function checkOkpayIps ($test_ipn) {
		return;
	}
  function _processIPN ($okpay_data) {
		$secure_post = true;
		// read the post from okpay system and add 'cmd'
		$post_msg = 'ok_verify=true';
		foreach ($okpay_data as $key => $value) {
			if ($key != 'view' && $key != 'layout') {
				$value = urlencode ($value);
				$post_msg .= "&$key=$value";
			}
		}
    $okpay_url='okpay.com';
		// post back to okpay system to validate
		$header = "POST /ipn-verify.html HTTP/1.0\r\n";
		$header .= "Host: ".$okpay_url."\r\n"; 
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen ($post_msg) . "\r\n\r\n";
		
		if ($secure_post) {
			// If possible, securely post back to okpay using HTTPS
			// Your PHP server will need to be SSL enabled
			$fps = fsockopen ('ssl://' . $okpay_url, 443, $errno, $errstr, 30);
		} else {
			$fps = fsockopen ($okpay_url, 80, $errno, $errstr, 30);
		}
		
		if (!$fps) {
			return 'error';
		} else {
			fputs ($fps, $header . $post_msg);
			while (!feof ($fps)) {
				$res = fgets ($fps, 1024);
				if (strcmp ($res, 'VERIFIED') == 0) {
					return '';
				} elseif (strcmp ($res, 'INVALID') == 0) {
					$emailBody = "Hello,\n\nerror with okpay IPN NOTIFICATION" . " " . $res . "\n";
					// If 'INVALID', send an email. TODO: Log for manual investigation.
					foreach ($okpay_data as $key => $value) {
						$emailBody .= $key . " = " . $value . "\n";
					}
					return 'error2';
				}
			}
		}
		fclose ($fps);
		return '';
	}
}